# -*- coding: latin1 -*-
# Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *

# Initialize Qt resources from file resources.py
from cadtools import resources

#Import own classes and tools
from horizontalverticaldigitizer import HorizontalVerticalDigitizer

class HorizontalVerticalDigitizerTool():
    
        def __init__(self, iface,  toolBar):
            self.iface = iface
            self.canvas = self.iface.mapCanvas()
            mc = self.canvas
            self.tool = None
            
            self.act_horivert = QAction(QIcon(":/plugins/cadtools/icons/hvdigitizer.png"),  "Capture Vertical/Horizontal Lines/Polygons",  self.iface.mainWindow())
            self.act_horivert.setEnabled(False)
            self.act_horivert.setCheckable(True)            
            
            QObject.connect(self.act_horivert,  SIGNAL("triggered()"),  self.hvdigitize)
            QObject.connect(self.iface, SIGNAL("currentLayerChanged(QgsMapLayer*)"), self.toggle)
            QObject.connect(mc, SIGNAL("mapToolSet(QgsMapTool*)"), self.deactivate)         
            
            toolBar.addSeparator()
            toolBar.addAction(self.act_horivert)

            self.tool = HorizontalVerticalDigitizer(self.canvas)
            

        def hvdigitize(self):
            mc = self.canvas
            layer = mc.currentLayer()
            
            mc.setMapTool(self.tool)
            self.act_horivert.setChecked(True)    


        def toggle(self):
            mc = self.canvas
            layer = mc.currentLayer()
            
            #Decide whether the plugin button/menu is enabled or disabled
            if layer <> None:
                # Only for vector layers
                type = layer.type()
                if type == 0:
                    gtype = layer.geometryType()
                    # Doesn't make sense for Points
                    if gtype <> 0:
                        if layer.isEditable():
                            self.act_horivert.setEnabled(True)
                            QObject.connect(layer,SIGNAL("editingStopped()"),self.toggle)
                            QObject.disconnect(layer,SIGNAL("editingStarted()"),self.toggle)
                        else:
                            self.act_horivert.setEnabled(False)
                            QObject.connect(layer,SIGNAL("editingStarted()"),self.toggle)
                            QObject.disconnect(layer,SIGNAL("editingStopped()"),self.toggle)                   


        def deactivate(self):
            self.act_horivert.setChecked(False)
            #QObject.disconnect(self.tool, SIGNAL("segmentsFound(PyQt_PyObject)"), self.storeSegmentPoints)                  
