# -*- coding: utf-8 -*-
"""
/***************************************************************************
Tools for Database Management
------------------------------------------------------------------------------------------------------------------
begin                 : 2010-07-31
copyright           : (C) 2010 by Dr. Horst Duester
email                 :  horst.duester@kappasys.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtSql import *
from qgis.gui import *
from qgis.core import *
from dbVersionCheckDialog import DbVersionCheckDialog 
from datetime import datetime
from dbTools import *
import time,  sys

class PgVersionTools:
    
## Konstruktor 
  def __init__(self):
      self.pgvsRevision = '1.8.1'
      pass

     
  def layerDB(self, connectionName,  uri):
      DBHOST = QgsDataSourceURI(uri).host()
      DBNAME = QgsDataSourceURI(uri).database()
      DBUSER = QgsDataSourceURI(uri).username()
      DBPORT = QgsDataSourceURI(uri).port()
      DBTYPE = "pg"
      DBPASSWD = QgsDataSourceURI(uri).password()
      
      try:
          myDb = DbObj(pluginname=connectionName,typ=DBTYPE,hostname=DBHOST,port=DBPORT,dbname=DBNAME,username=DBUSER, passwort=DBPASSWD)
          return myDb
      except:
          QMessageBox.information(None, QCoreApplication.translate('PgVersionTools','Error'), QCoreApplication.translate('PgVersionTools','No Database Connection Established.'))
          return
    
     
  def setConfTable(self,  theLayer):
      provider = theLayer.dataProvider()
      uri = provider.dataSourceUri() 
      myDb = layerDB('setConfTable',  uri)
      mySchema = QgsDataSourceURI(uri).schema()
      myTable = QgsDataSourceURI(uri).table()
      if len(mySchema) == 0:
          mySchema = 'public'

      myTable = myTable.remove("_version")
      sql = "select versions.pgvscommit('"+mySchema+"."+myTable+"')"
      result = myDb.read(sql)
      myDb.close()
      
      timeListString = ''          


  def isModified(self, myLayer):

    myLayerUri = QgsDataSourceURI(myLayer.source())
    myDb = self.layerDB('isModiefied',  myLayerUri)

    if myLayerUri.schema().count() == 0:
      schema = 'public'
    else:
      schema = myLayerUri.schema()

    sql = "select count(project) "
    sql +="from versions."+schema+"_"+myLayerUri.table()+"_log "
    sql += "where project = '"+myDb.dbUser()+"' and not commit" 

    result = myDb.read(sql)
    myDb.close()

    if int(result["COUNT"][0]) == 0:
      return False
    else:
      return True      
      
  def setModified(self, dummy, myLayer):
    if self.isModified(myLayer):
      if not myLayer.name().contains('(modified)'):
        myLayer.setLayerName(myLayer.name()+' (modified)')
    else:
      myLayer.setLayerName(myLayer.name().remove('(modified)'))      
      
# Return QgsVectorLayer from a layer name ( as string )
  def vectorLayerExists(self,   myName ):
     layermap = QgsMapLayerRegistry.instance().mapLayers()
     for name, layer in layermap.iteritems():
         if layer.type() == QgsMapLayer.VectorLayer and layer.name() == myName:
             if layer.isValid():
                 return True
             else:
                 return False



  def versionExists(self,uri):
  
      myDb = self.layerDB('versionExists',  uri)
  
      try: 
          myTable = QgsDataSourceURI(uri).table()       
          mySchema = QgsDataSourceURI(uri).schema()
          
          if mySchema == '':
              mySchema = 'public'
          
          sql =    "select version_table_schema as schema, version_table_name as table "
          sql += "from versions.version_tables "
          sql += "where (version_view_schema = '"+mySchema+"' and version_view_name = '"+myTable+"') "
          sql += "  or (version_table_schema = '"+mySchema+"' and version_table_name = '"+myTable+"')"
          result  = myDb.read(sql)
          myDb.close()
          
          if len(result["SCHEMA"]) <> 0:
            QMessageBox.information(None, '', QCoreApplication.translate('PgVersionTools','Table ')+mySchema+'.'+myTable+QCoreApplication.translate('PgVersionTools',' is already versionized'))
            return True
          else:
            return False
      except:
            QMessageBox.information(None, '', QCoreApplication.translate('PgVersionTools','pgvs is not installed in your database \n\n Please download the pgvs functions from \n\n http://www.kappasys.ch/pgtools/pgversion/createFunctions.sql\n\n and install them as mentioned in help') )
            return True

  def createGridView(self, tabView, tabData, headerText, colWidth, rowHeight):
    
    numCols = len(headerText)
    startVal = 0
      
    numRows = len(tabData[headerText[0].upper()])
   
    tabView.clear()
    tabView.setColumnCount(numCols)
    
    tabView.setRowCount(numRows)
      
    tabView.sortItems(2)
    col = startVal
    
    i = 0
    for text in headerText:
      headerItem = QTableWidgetItem()
      headerItem.setData(Qt.DisplayRole,QVariant(text))
      tabView.setHorizontalHeaderItem(i,headerItem)
      i = i+1
    
    
    for i in range(0,numRows):
      
      col = startVal


      for text in headerText:
        myItem = QTableWidgetItem()
        myItem.setData(Qt.DisplayRole,QVariant(tabData[text.upper()][i]))   
        tabView.setItem(i,col,myItem)
        myItem.setSelected(False)
        col = col + 1
      
    pass
           
  def confRecords(self, theLayer):
      confRecords = []
      provider = theLayer.dataProvider()
      uri = provider.dataSourceUri()    
      myDb = self.layerDB('getConfRecord',  uri)
      mySchema = QgsDataSourceURI(uri).schema()
      myTable = QgsDataSourceURI(uri).table()
      if len(mySchema) == 0:
          mySchema = 'public'
            
      sql =    "select version_table_schema as schema, version_table_name as table "
      sql += "from versions.version_tables "
      sql += "where version_view_schema = '"+mySchema+"' and version_view_name = '"+myTable+"'"
      result  = myDb.read(sql)
      
      if len(result["SCHEMA"]) == 0:
        QMessageBox.information(None, '', QCoreApplication.translate('PgVersionTools','Table '+self.mySchema+'.'+self.myTable+' is not versionized'))
        return
      else:
        sql = "select * from versions.pgvscheck('"+result["SCHEMA"][0]+"."+result["TABLE"][0]+"')"
        result = myDb.read(sql)
        myDb.close()
        
      confRecords.append(QCoreApplication.translate('PgVersionTools','select Candidate'))
      
      try:  
        if len(result["PROJECT"]) > 0:
          message = ''
        
          for i in range(len(result["PROJECT"])):
              resString = result["OBJECTKEY"][i]+" - "+result["MYPROJECT"][i]+" - "+datetime.strftime(datetime.fromtimestamp(float(result["MYSYSTIME"][i])/1000.0), "%x %H:%M:%S")
              confRecords.append(resString)
              resString = result["OBJECTKEY"][i]+" - "+result["PROJECT"][i]+" - "+datetime.strftime(datetime.fromtimestamp(float(result["SYSTIME"][i])/1000.0), "%x %H:%M:%S")
              confRecords.append(resString)
      except:
        QMessageBox.information(None, QCoreApplication.translate('PgVersionTools','Error'), QCoreApplication.translate('PgVersionTools','Please set the appropriate permissions for the table: ')+mySchema+'.'+myTable.remove('_version'))
        try:
          confRecords.remove('select Candidate')
        except:
          return None
        
      return confRecords
      
  def tableRecords(self,  theLayer):      
      provider = theLayer.dataProvider()
      uri = provider.dataSourceUri()    
      myDb = self.layerDB('tableRecords',  uri)
      mySchema = QgsDataSourceURI(uri).schema()
      myTable = QgsDataSourceURI(uri).table()
      if len(mySchema) == 0:
          mySchema = 'public'
          
      sql =   "select * from versions.version_tables "
      sql += "where version_view_schema = '"+mySchema+"' and version_view_name = '"+myTable+"'"
      layer = myDb.read(sql)              
          
      sql = "select objectkey, mysystime, systime from versions.pgvscheck('"+mySchema+"."+myTable.remove("_version")+"')"
      result = myDb.read(sql)          
      timeListString = ''
      keyString = ''

      for i in range(len(result["SYSTIME"])):
          timeListString += result["MYSYSTIME"][i]+","+result["SYSTIME"][i]+","
          keyString += result["OBJECTKEY"][i]+","

      timeListString = timeListString[0:len(timeListString)-1]
      keyString = keyString[0:len(keyString)-1]
      
      sql = "select * "
      sql += "from versions."+mySchema+"_"+myTable+"_version_log "
      sql += "where systime in ("+timeListString+")"
      sql += "  and "+layer["VERSION_VIEW_PKEY"][0]+" in ("+keyString+") "
      sql += "order by "+layer["VERSION_VIEW_PKEY"][0]
      result = myDb.read(sql)
      
      cols = myDb.cols(sql)
      
      sql = "select f_geometry_column as geocol "
      sql += "from geometry_columns "
      sql += "where f_table_schema = '"+mySchema+"' "
      sql += "  and f_table_name = '"+myTable+"' "
      geomCol = myDb.read(sql)
      
      cols.remove('ACTION')
      cols.remove('SYSTIME')
      cols.remove('COMMIT')
      cols.remove(geomCol["GEOCOL"][0].toUpper())
      
      cols.insert(0, cols.pop(-1))
      cols.insert(0, cols.pop(-1))
      cols.insert(0, cols.pop(-1))
      
      resultArray = []
      resultArray.append(result)
      resultArray.append(cols)
      
      myDb.close()
      return resultArray
      
      

  def conflictLayer(self,  theLayer):
        provider = theLayer.dataProvider()
        uri = provider.dataSourceUri()    
        myDb = self.layerDB('getConflictLayer',  uri)
        mySchema = QgsDataSourceURI(uri).schema()
        myTable = QgsDataSourceURI(uri).table()
        if len(mySchema) == 0:
          mySchema = 'public'
            
        sql =   "select * from versions.version_tables "
        sql += "where version_view_schema = '"+mySchema+"' and version_view_name = '"+myTable+"'"
        layer = myDb.read(sql)    
        
        uri = QgsDataSourceURI()
        
#        # set host name, port, database name, username and password
        uri.setConnection(myDb.dbHost(), str(myDb.dbPort()), myDb.dbName(), myDb.dbUser(), myDb.dbPasswd())    
        
        sql = "select * from versions.pgvscheck('"+mySchema+"."+myTable.remove("_version")+"')"
        result = myDb.read(sql)
        myFilter = ''
        for i in range(len(result["OBJECTKEY"])):
            key = result["OBJECTKEY"][i]
            myproject = result["MYPROJECT"][i]
            mysystime = result["MYSYSTIME"][i]
            project = result["PROJECT"][i]
            systime = result["SYSTIME"][i]
            myFilter += "("+layer["VERSION_VIEW_PKEY"][0]+"="+key+" and systime = "+systime+") or ("+layer["VERSION_VIEW_PKEY"][0]+"="+key+" and systime = "+mysystime+") or "

        if len(myFilter) > 0:
           myFilter = myFilter[0:len(myFilter)-4]  
           uri.setDataSource("versions", mySchema+"_"+myTable+"_version_log", layer["VERSION_VIEW_GEOMETRY_COLUMN"][0], myFilter,  layer["VERSION_VIEW_PKEY"][0])
    
           layerName = myTable+"_conflicts"
           vLayer = QgsVectorLayer(uri.uri(), layerName, "postgres")
           userPluginPath = QFileInfo(QgsApplication.qgisUserDbFilePath()).path()+"/python/plugins/pgversion"  
           vLayer.setRenderer(None)
           vLayer.setRendererV2(None)
           vLayer.loadNamedStyle(userPluginPath+"/tools/conflict.qml")   
           
           myDb.close()
           return vLayer    
       
       
  def createPolygon(self, geometry, geometryType):      
            
    self.mRubberBand.reset()
    project = QgsProject.instance()
    
    color = QColor(255,0,0)
    self.mRubberBand.setColor(color)
    self.mRubberBand.setWidth(5)
    self.mRubberBand.show()
    
    g = QgsGeometry.fromWkt(geometry)
    
#    self.mRubberBand.setToGeometry(g,  None)
    
    if geometryType == "MULTIPOLYGON":
      for i in g.asMultiPolygon():
        index = 0
        for n in i:
          for k in n: 
            self.mRubberBand.addPoint(k,  False,  index)
          index = index + 1

#    if geometryType == "MULTILINESTRING":
#      for i in g.asPolyline():
#        for k in i: 
#          self.mRubberBand.addPoint(k)

    elif geometryType == "POLYGON":
      for i in g.asPolygon():
        for k in i: 
          self.mRubberBand.addPoint(k,  False)
            

    elif geometryType == "POINT":
      gBuffer = g.buffer(25, 100)
      for i in gBuffer.asPolygon():
        for k in i: 
          self.mRubberBand.addPoint(k)
        

    return 0                      
    
  def lastOptions(self):
    self.settings = QSettings("SOGIS","SogisSuche")
    gemeinde = self.settings.value("suche/gemeinde")
    strasse = self.settings.value("suche/strasse")
    hausnr = self.settings.value("suche/hausnummer")
    gbnr = self.settings.value("suche/gbnr")     
    xKoord = self.settings.value("suche/xKoord")
    yKoord = self.settings.value("suche/yKoord")       
    
# Check the revision of the DB-Functions
  def checkPGVSRevision(self,  myDb):      
      try:
          check = QString(myDb.runError('select * from versions.pgvsrevision()'))
#          QMessageBox.information(None, '', check)
          if (check.contains("QPSQL") ):
                self.vsCheck = DbVersionCheckDialog(myDb,  '0.0.0')
                revisionMessage =QCoreApplication.translate('PgVersionTools', 'pgvs is not installed in the selected DB.\n\nPlease contact your DB-administrator to install the DB-functions from the file:\n\n<Plugin-Directory>/pgversion/tools/createFunctions.sql\n\nIf you have appropriate DB permissions you can install the DB functions directly with click on Install pgvs.')
                self.vsCheck.messageTextEdit.setText(revisionMessage)
                self.vsCheck.btnUpdate.setText('Install pgvs')
                self.vsCheck.show()
                return False
          else:  
            result = myDb.read('select * from versions.pgvsrevision()')
            if self.pgvsRevision != result["PGVSREVISION"][0]:
                self.vsCheck = DbVersionCheckDialog(myDb,  result["PGVSREVISION"][0])              
                revisionMessage =QCoreApplication.translate('PgVersionTools', 'The Plugin expects pgvs revision ')+self.pgvsRevision+QCoreApplication.translate('PgVersionTools', ' but DB-functions revision ')+result["PGVSREVISION"][0]+QCoreApplication.translate('PgVersionTools', ' are installed.\n\nPlease contact your DB-administrator to update the DB-functions from the file:\n\n<Plugin-Directory>/pgversion/tools/updateFunctions.sql\n\nIf you have appropriate DB permissions you can update the DB directly with click on DB-Update.')
                self.vsCheck.messageTextEdit.setText(revisionMessage)
                self.vsCheck.show()
                return False
            else:
              return True
      except:
          self.vsCheck = DbVersionCheckDialog(myDb,  '0.0.0')
          revisionMessage = QCoreApplication.translate('PgVersionTools','Please upgrade the DB-functions from the file:\n\n<Plugin-Directory>/pgversion/tools/updateFunctions.sql\n\nIf you have appropriate DB permissions you can update the DB directly with click on DB-Update.')
          self.vsCheck.messageTextEdit.setText(revisionMessage)
          self.vsCheck.show()          
          return False    

    
#Get the Fieldnames of a Vector Layer
#Return: List of Fieldnames
  def getFieldNames(self, vLayer):
    provider = vLayer.dataProvider()      
    myList = self.getFieldList(vLayer)

    fieldList = []    
    for (k,attr) in myList.iteritems():
       fieldList.append(unicode(attr.name(),'latin1'))

    return fieldList

#Get the List of Fields
#Return: QGsFieldMap
  def getFieldList(self, vlayer):
    fProvider = vlayer.dataProvider()

    feat = QgsFeature()
    allAttrs = fProvider.attributeIndexes()

# start data retrieval: all attributes for each feature
    fProvider.select(allAttrs, QgsRectangle(), False)

# retrieve every feature with its attributes
    myFields = fProvider.fields()
      
    return myFields
        
