#-----------------------------------------------------------
#
# Rectangles, Ovals, Diamonds
# Copyright (C) 2011 - 2012 Pavol Kapusta <pavol.kapusta@gmail.com>
# Copyright (C) 2011 Benjamin Bohard <benjamin.bohard@orange.fr>
# 
#-----------------------------------------------------------
# 
# licensed under the terms of GNU GPL 2
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
# 
#---------------------------------------------------------------------

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from qgis.gui import *

import resources
import rectovaldiams_plugin

class rectangleovaldiamonds:

    def __init__(self, iface):
        self.iface = iface


    def initGui(self):
        # create action 
        self.action = QAction(QIcon(':/plugins/rectovaldiams/icon.png'), 'Rectangles, Ovals, Diamonds', self.iface.mainWindow())
        self.action.setWhatsThis('Tool for creating rectangles, ovals, diamonds around centers')
        QObject.connect(self.action, SIGNAL('triggered()'), self.run)
        # add toolbar button and menu item
        self.iface.addToolBarIcon(self.action)
        self.iface.addPluginToMenu('&Rectangles, Ovals, Diamonds', self.action)


    def unload(self):
        # remove the plugin menu item and icon
        self.iface.removePluginMenu('&Rectangles, Ovals, Diamonds',self.action)
        self.iface.removeToolBarIcon(self.action)


    def run(self):
        caution = QMessageBox.warning( self.iface.mainWindow(), "Rectangles, Ovals, Diamonds", "This plugin is working properly if your input point layer"  + "\n"
                                                               + "is projected in coordinate system which Northings and Eastings"  + "\n"
                                                               + "are measured in meters and your width and height values are set in meters." )
        dialog = rectovaldiams_plugin.RectOvalDiams(self.iface)
        dialog.exec_()
    
