# -*- coding: utf-8 -*-
"""
/**************************************************************************
    Starting date        : 2010-05-10
    Credits              : (C) 2010 by Fidel Serrano and Rodrigo Tapia
    Contact              : fidel at centrogeo.org.mx, rtapia at centrogeo.org.mx
 *************************************************************************/
/**************************************************************************
 *   This program is free software; you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published by *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *   (at your option) any later version.                                  *
 *************************************************************************/
"""
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import PyQt4.Qwt5 as Qwt
from PyQt4.Qwt5 import *
from PyQt4.Qt import *
from PyQt4 import Qt
from qgis.core import *
import resources_sp
import math
from spectralmaptool import *
from ui_spectral import Ui_infoDialog

existo = False
contador = 0
layer = "null"
saveTool = ""
cerrando = False
limpiando = False
colores = [Qt.red, Qt.blue, Qt.darkGreen, QColor(255, 204, 51), Qt.lightGray]
colores2 = [Qt.red, Qt.blue, Qt.darkGreen, QColor(255, 204, 51), Qt.darkGray]
maximo=0
vl = []
a = []
b = []
arrayValoresPuntos = []
miplot = QwtPlotCurve('Profile')

class SpectralPlugin(QDialog, Ui_infoDialog):
    
  def __init__(self, iface):
    QDialog.__init__(self)
    self.iface = iface
    self.setupUi(self)
    self.canvas = iface.mapCanvas()
    QObject.connect(self.butReset, SIGNAL("clicked()"), self.plotReset)
    QObject.connect(self.btnClose, SIGNAL("clicked()"), self.plotClose)
    QObject.connect(self.butExport, SIGNAL("clicked()"), self.exportCSV)
    # setting up the main plotting widget

  def initGui(self):
    # Create action that will start plugin configuration
    self.action = QAction(QIcon(":/icon_spectral.png"), \
                          "Spectral Profile", self.iface.mainWindow())
    self.action.setWhatsThis("Spectral Profile")
    self.helpaction = QAction(QIcon(":/icon_about.png"), \
                              "About", self.iface.mainWindow())
    self.helpaction.setWhatsThis("Help")
    QObject.connect(self.action, SIGNAL("triggered()"), self.spectralrun)
    QObject.connect(self.helpaction, SIGNAL("triggered()"), self.helprun)
    self.iface.addToolBarIcon(self.action)
    self.iface.addPluginToMenu("&Spectral Profile", self.action)
    self.iface.addPluginToMenu("&Spectral Profile", self.helpaction)
    self.tool = spectralMapTool(self.canvas)

  def unload(self):
    # Remove the plugin
    self.iface.removePluginMenu("&Spectral Profile",self.action)
    self.iface.removePluginMenu("&Spectral Profile",self.helpaction)
    self.iface.removeToolBarIcon(self.action)

    QObject.disconnect(self.iface.mapCanvas(), \
            SIGNAL("renderComplete(QPainter *)"), self.renderTest)

  def renderTest(self, painter):
    self.close

  def helprun(self):
    import __init__
    helpText = "Written by: Fidel Serrano & Rodrigo Tapia-McClung\n\n" + \
               "E-mail: fidel@centrogeo.org.mx,\n             rtapia@centrogeo.org.mx\n\n" + \
               "More information about the plugin:\n" + \
               "http://geoweb.centrogeo.org.mx/" + \
               "\n\nPlugin " + __init__.version()
    QMessageBox.information(self.iface.mainWindow(), \
                            "Spectral Profile About", helpText)

  def spectralrun(self):
    global contador 
    global existo
    global layer
    global saveTool
    global cerrando	
    if existo:
        self.activateWindow()  
        self.canvas.setMapTool(self.tool)
        self.raise_()     
    else:       
    #if contador == 0:  
        if self.iface.mapCanvas().layerCount() == 0:
            QMessageBox.warning(self.iface.mainWindow(), "Spectral Profile", "Please add raster layer")
            return 1
        layer = self.iface.activeLayer()
        if layer == None or layer.type() != layer.RasterLayer:
            QMessageBox.warning(self.iface.mainWindow(), "Spectral Profile", "Please select raster layer")
            return 2
        else: 
            QObject.connect(self.tool, SIGNAL("finished(PyQt_PyObject)"), \
                            self.finished)
            QObject.connect(QgsMapLayerRegistry.instance(),SIGNAL("layerWillBeRemoved(QString)"),self.quienSeFue)
            saveTool = self.canvas.mapTool()
            self.canvas.setMapTool(self.tool)
            existo = True
            cerrando = False
            
			
  def quienSeFue(self, theLayerId):
    global saveTool
    global layer
    global cerrando
    if not cerrando and not limpiando:
      if theLayerId==layer.getLayerID() or theLayerId.contains('spectralP_'):
        QObject.disconnect(self.tool, SIGNAL("finished(PyQt_PyObject)"),self.finished)
        self.canvas.setMapTool(saveTool)
        cerrando = True
        self.plotClose()

		
  def finished(self,xy):
    global contador
    global vl
    global miplot
    global a
    global b
    global maximo
    global limpiando
    global arrayValoresPuntos
    limpiando = False
    if contador<5: 
      transform = self.canvas.getCoordinateTransform()
      mapCoords = transform.toMapCoordinates(xy["x"],xy["y"])
      extent = layer.extent()
      isFeatureFound = 0
      if mapCoords.x() > extent.xMinimum() and \
         mapCoords.x() < extent.xMaximum() and \
         mapCoords.y() > extent.yMinimum() and \
         mapCoords.y() < extent.yMaximum():
        isFeatureFound = 1
        ident = layer.identify(QgsPoint(mapCoords.x(),mapCoords.y()))
      if isFeatureFound == 0:
        QMessageBox.warning(self.iface.mainWindow(), "Spectral Profile", "No features here!")
      else:
        vl += [QgsVectorLayer('Point', 'spectralP_'+str(contador+1), 'memory')]
	#Create Layer
        pr = vl[contador].dataProvider()
		  # add a feature
        point = QgsPoint()
        point.setX(mapCoords.x())
        point.setY(mapCoords.y())
        geom = QgsGeometry()
        fet = QgsFeature()
        fet.setGeometry(geom.fromPoint(point))
        pr.addFeatures( [ fet ] )

	if vl[contador].isUsingRendererV2():
	# new symbology - subclass of QgsFeatureRendererV2 class
	  symbols = vl[contador].rendererV2().symbols()
	  symbol = symbols[0]
	  symbol.setColor(colores[contador])
	else:
	# old symbology - subclass of QgsRenderer class
          symbols = vl[contador].renderer().symbols()
	  symbol = symbols[0]
	  symbol.setFillColor(colores[contador])
	 
        vl[contador].updateExtents()
        QgsMapLayerRegistry.instance().addMapLayer(vl[contador])
        self.show()
        a = []
        b = []
  # reading data
  #if nLayers > 0:
  #QgsMapLayerRegistry.instance().addMapLayer(vl[contador])
        for n in range(1, layer.bandCount()+1):
          a += [n]
          try:
              b += [int(ident[1].values()[n-1])]
          except:
               try:
                  b += [float(ident[1].values()[n-1])]
               except:
                  b += [0]
              #aqui algo cuando no es ni entero no real 			
 #filling the main data dictionary "profiles"
 #self.miplot = Qwt.QwtPlotCurve(str(layer.name()))
        self.qwtPlot.canvas()
        self.qwtPlot.setCanvasLineWidth(3)
        self.qwtPlot.setCanvasBackground(Qt.white)
 #self.qwtPlot.plotLayout().setAlignCanvasToScales(True)
        
        esteMaximo = max(b)
        maximo = max(maximo,esteMaximo)
        if maximo>0:            
            maximoEntre5 = maximo/5.0
            orden = math.floor(math.log10(maximoEntre5))
            numeroMagico = pow(10,orden) 		
            marcando_cada = numeroMagico * round( maximoEntre5 / numeroMagico )
        else:
            marcando_cada = 1
        self.qwtPlot.setAxisScale(0, 0,maximo,marcando_cada)
        self.qwtPlot.setAxisScale(2, 1, layer.bandCount(),1)
        self.qwtPlot.setAxisTitle(0,"Pixel Values")
        self.qwtPlot.setAxisTitle(2,"Bands")
 #self.qwtPlot.setAxisScale(1, 1,layer.bandCount()+1,1)
        miplot = QwtPlotCurve('Profile')
        miplot.setPen(QPen(colores2[contador], 3))
        miplot.setData(a, b)
        miplot.attach(self.qwtPlot)
        c = b
        c += [mapCoords.x()]
        c += [mapCoords.y()]
        arrayValoresPuntos += [c]
 # updating everything
        miplot.setSymbol(QwtSymbol(QwtSymbol.Ellipse,QBrush(),QPen(colores2[contador]),QSize(7,7)))
        contador += 1    
        self.qwtPlot.replot()
    self.activateWindow()
    self.raise_()
  def saveDialog(parent):
    outFilePath = QFileDialog.getSaveFileName(parent, parent.tr('Save output csv file'))
    if outFilePath:
        dir = QDir(outFilePath)
        dir.cdUp()
        outPath = dir.absolutePath()
        settings.setValue(key, outPath)
    return outFilePath         
      

  def plotReset(self):
   global vl
   global a
   global b
   global contador
   global miplot
   global limpiando
   limpiando = True
   for i in range (0,contador):
     QgsMapLayerRegistry.instance().removeMapLayer(vl[i].getLayerID())

   contador = 0
   vl = []
   a = []
   b = []
   self.qwtPlot.detachItems()
   self.qwtPlot.replot()


  def plotClose(self):
    global vl
    global a
    global b
    global contador
    global maximo
    for i in range (0,contador):
      try:
        QgsMapLayerRegistry.instance().removeMapLayer(vl[i].getLayerID())
      except:
        h = 0	  
    contador = 0
    vl = []
    a = []
    b = []
    maximo = 0 	
    self.qwtPlot.detachItems()
    self.close()
  
  def exportCSV(self):
      global arrayValoresPuntos
      self.csvName = QFileDialog.getSaveFileName(self, self.tr('Save output csv file'))
      if not self.csvName:
          return
      
      inPath = QFileInfo(self.csvName).absoluteFilePath()
      
      fout = open(inPath, "w")
      for i in range (0,contador):
          fout.write("Point"+str(i+1)+",")
          for j in range (0,len(arrayValoresPuntos[i])):
              fout.write(str(arrayValoresPuntos[i][j]))
              if j < len(arrayValoresPuntos[i])-1:
                  fout.write(",")
              else:
                  fout.write("\n")    
      fout.close()
        
  def closeEvent(self, event):
    global saveTool
    global existo
    QObject.disconnect(self.tool, SIGNAL("finished(PyQt_PyObject)"),self.finished)
    self.canvas.setMapTool(saveTool)
    existo = False    
    self.plotClose()
    self.close()
    
  def reject(self):
    self.plotClose()
    self.close()
    
    
    
